//SI5351_vfo

#include <Adafruit_Sensor.h>

#include <Wire.h>
#include <Adafruit_SI5351.h>

Adafruit_SI5351 clockgen = Adafruit_SI5351();
void setup(void) 

{
  Serial.begin(9600);
  Serial.println("Si5351 VFO"); Serial.println("");

  if (clockgen.begin() != ERROR_NONE)
  {
    Serial.print("Error");
    while(1);
  }
  Serial.println("OK");
  clockgen.enableOutputs(true);
  setfreq (6000);
}

void setfreq (unsigned long freq)
{
  unsigned long f2;
  unsigned long f3;
  unsigned long f4;
  unsigned long f5;
  unsigned int Teiler2;
  unsigned int rdiv;
  
   if (freq > 0)
   {  
   f2=(freq-12)*4;
   // f2=freq;
    if (f2>120000) {
      f2=120000;
    } 
    if (f2<800) {
       rdiv = 16;
       f2 = f2 * 16;
    }
    else  {
       clockgen.setupRdiv(1, SI5351_R_DIV_1);
       rdiv = 1;
    }   
    if (f2 >= 100000) {
      Teiler2 = 6;    
     } 
     if (f2 < 90000) {
      Teiler2 = 10;    
     } 
     if (f2 < 60000) {
      Teiler2 = 15;    
     } 
     if (f2 < 50000) {
      Teiler2 = 18;    
     } 
     if (f2 < 45000) {
      Teiler2 = 20;   
     }  
     if (f2 < 30000) {
      Teiler2 = 30;   
     } 
     if (f2 < 20000) {
      Teiler2 = 45;    
     }
     if (f2 < 15000) {
      Teiler2 = 60;    
     }
     if (f2 < 10000) {
      Teiler2 = 90;    
     } 
     if (f2 < 6000) {
      Teiler2 = 150;    
     } 
    if (f2 < 4000) {
      Teiler2 = 220;    
     } 
    if (f2 < 2700) {
      Teiler2 = 330;    
     } 
    if (f2 < 1800) {
      Teiler2 = 500;    
     } 
    if (f2 < 1500) {
      Teiler2 = 600;    
     } 
    if (f2 < 1000) {
      Teiler2 = 900;    
     }    
    f2=f2*Teiler2; 
    f2=f2*1000/25;    
    f3=f2 /1000;
    f4 = f3/1000;
    f5=f3-(f4*1000);
    clockgen.setupPLL(SI5351_PLL_A, f4, f5, 1000);
    clockgen.setupMultisynth(1, SI5351_PLL_A, Teiler2, 0, 2);
    if (rdiv == 16) {
      clockgen.setupRdiv(1, SI5351_R_DIV_16);
    }
   }     
}

void loop(void) 
{     
  unsigned long freq;
  if (Serial.available()) {
   freq = Serial.parseInt();
   setfreq (freq);
  }
}
